
Application: gvSIG desktop - gvSIG bugs #5182
Al editar vertices en una tabla de H2 falla.
12/12/2019 11:12 AM - Joaquín  del Cerro Murciano

Status: Closed % Done: 0%
Priority: Normal Spent time: 0.00 hour
Assignee: Joaquín  del Cerro Murciano
Category:
Target version: 2.5.1-3003 (rev. org.gvsig.desktop-2.0.261)
Severity: Minor Add-on version:
gvSIG version: 2.5.0 Add-on build:
gvSIG build: Add-on resolve version:
Operative System: Add-on resolve build:
Keywords: Proyecto:
Has patch: Hito:
Add-on name: Unknown
Description

[Sobre 2.5.1 build 3002]
Cargamos la tabla "capa_lineas" de la BBDD "fotografia_puerto_Valencia_actual".
Seleccionamos la linea correspondiente al pk 11, (Juan verdeguer).
Movemos dos vertices con la herramienta de editar vertices.
Terminamos edicion guardando cambios y falla.

DEBUG 1303641 [AWT-EventQueue-0] (AbstractConnectionOperation.java:100) - Excuting operation
PerformChangesOperation.
DEBUG 1584831 [AWT-EventQueue-0] (JDBCUtils.java:109) - execute update SQL= UPDATE "PUBLIC"."capa_lineas" SET
"GEOMETRY" = ST_GeomFromWKB((?), (?)), "Campo1" = ? WHERE ( ("pk") = (?) ) [[ prep986: UPDATE
"PUBLIC"."capa_lineas" SET "GEOMETRY" = ST_GeomFromWKB((?), (?)), "Campo1" = ? WHERE ( ("pk") = (?) ) {1:
X'00000000020000000b4095de928eea490c4099d4bd00bad1d24095dff50e9d61a74099d2312eb3940f4095aaa33050697f4099b6066b1574cc40952f350503a059409986b2adca5cb640949f0f5b938851409946bd18036ede40945189ee40dea740992a099257621b40940097f7c53b0a409908b045c088214093b09ab96a3d454098e65f2d9469e440937dcfa6f154b54098d1521fcbba3c409306323acc4bdd4098910af33019c34092db55da039afb40983b43645bff5e', 2: 25830, 3: 'Juan Verdeguer', 4: NULL} ]]
DEBUG 1584832 [AWT-EventQueue-0] (H2SpatialHelper.java:268) - closeConnection: connection = 671068603
DEBUG 15848
9b6066b1574cc40952f350503a059409986b2adca5cb640949f0f5b938851409946bd18036ede40945189ee40dea740992a099257621b40940097f7c53b0a409908b045c088214093b09ab96a3d454098e65f2d9469e440937dcfa6f154b54098d1521fcbba3c409306323acc4bdd4098910af33019c34092db55da039afb40983b43645bff5e', 2: 25830, 3: 'Juan Verdeguer', 4: NULL} ]]
DEBUG 1584832 [AWT-EventQueue-0] (H2SpatialHelper.java:268) - closeConnection: connection = 671068603
DEBUG 1584832 [AWT-EventQueue-0] (JDBCHelperBase.java:353) - Clossing connection 671068603
 INFO 1584832 [AWT-EventQueue-0] (DefaultEditingContext.java:577) - Changes can not be saved in capa_lineas
org.gvsig.vectored
57621b40940097f7c53b0a409908b045c088214093b09ab96a3d454098e65f2d9469e440937dcfa6f154b54098d1521fcbba3c409306323acc4bdd4098910af33019c34092db55da039afb40983b43645bff5e', 2: 25830, 3: 'Juan Verdeguer', 4: NULL} ]]
DEBUG 1584832 [AWT-EventQueue-0] (H2SpatialHelper.java:268) - closeConnection: connection = 671068603
DEBUG 1584832 [AWT-EventQueue-0] (JDBCHelperBase.java:353) - Clossing connection 671068603
 INFO 1584832 [AWT-EventQueue-0] (DefaultEditingContext.java:577) - Changes can not be saved in capa_lineas
org.gvsig.vectorediting.lib.api.exceptions.EndEditingException: An error has been produced ending edition.
        at org.gvsig.vectorediting.swing.impl.DefaultEditingContext.saveChanges(DefaultEditingContext.java:996)
      
9306323acc4bdd4098910af33019c34092db55da039afb40983b43645bff5e', 2: 25830, 3: 'Juan Verdeguer', 4: NULL} ]]
DEBUG 1584832 [AWT-EventQueue-0] (H2SpatialHelper.java:268) - closeConnection: connection = 671068603
DEBUG 1584832 [AWT-EventQueue-0] (JDBCHelperBase.java:353) - Clossing connection 671068603
 INFO 1584832 [AWT-EventQueue-0] (DefaultEditingContext.java:577) - Changes can not be saved in capa_lineas
org.gvsig.vectorediting.lib.api.exceptions.EndEditingException: An error has been produced ending edition.
        at org.gvsig.vectorediting.swing.impl.DefaultEditingContext.saveChanges(DefaultEditingContext.java:996)
        at org.gvsig.vectorediting.swing.impl.DefaultEditingContext.doAction(DefaultEditingContext.java:572)
        at org.gvsig.vectorediting.swing.impl.DefaultEditingContext.endEdition(DefaultEditingContext.java:684)
        at org.gvsig.vectorediting.app.mainplugin.EditingExtension.execute(EditingExtension.java:124)
        at org.gvsig.app.project.documents.view.toc.actions.EndEditingTocMenuEntry.execute(EndEditingTocMenuEntry.java:72)
        at
org.gvsig.app.project.documents.view.toc.AbstractTocContextMenuAction.execute(AbstractTocContextMenuAction.java:63)
        at org.gvsig.app.project.documents.view.toc.gui.FPopupMenu$MenuItem.actionPerformed(FPopupMenu.java:248)
        at java.desktop/javax.swing.AbstractButton.fireActionPerformed(AbstractButton.java:1967)
        at java.desktop/javax.swing.AbstractButton$Handler.actionPerformed(AbstractButton.java:2308)
        at java.desktop/javax.swing.DefaultButtonModel.fireActionPerformed(DefaultButtonModel.java:405)
        at java.desktop/javax.swing.DefaultButtonModel.setPressed(DefaultButtonModel.java:262)
        at java.desktop/javax.swing.AbstractButton.doClick(AbstractButton.java:369)
        at java.desktop/javax.swing.plaf.basic.BasicMenuItemUI.doClick(BasicMenuItemUI.java:980)
        at java.desktop/javax.swing.plaf.basic.BasicMenuItemUI$Handler.mouseReleased(BasicMenuItemUI.java:1024)
        at java.desktop/java.awt.Component.processMouseEvent(Component.java:6589)
        at java.desktop/javax.swing.JComponent.processMouseEvent(JComponent.java:3342)
        at java.desktop/java.awt.Component.processEvent(Component.java:6354)
        at java.desktop/java.awt.Container.processEvent(Container.java:2261)
        at java.desktop/java.awt.Component.dispatchEventImpl(Component.java:4966)
        at java.desktop/java.awt.Container.dispatchEventImpl(Container.java:2319)
        at java.desktop/java.awt.Component.dispatchEvent(Component.java:4798)
        at java.desktop/java.awt.LightweightDispatcher.retargetMouseEvent(Container.java:4914)
        at java.desktop/java.awt.LightweightDispatcher.processMouseEvent(Container.java:4543)
        at java.desktop/java.awt.LightweightDispatcher.dispatchEvent(Container.java:4484)
        at java.desktop/java.awt.Container.dispatchEventImpl(Container.java:2305)
        at java.desktop/java.awt.Window.dispatchEventImpl(Window.java:2772)
        at java.desktop/java.awt.Component.dispatchEvent(Component.java:4798)
        at java.desktop/java.awt.EventQueue.dispatchEventImpl(EventQueue.java:772)
        at java.desktop/java.awt.EventQueue.access$600(EventQueue.java:97)
        at java.desktop/java.awt.EventQueue$4.run(EventQueue.java:721)
        at java.desktop/java.awt.EventQueue$4.run(EventQueue.java:715)
        at java.base/java.security.AccessController.doPrivileged(Native Method)
        at java.base/java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(ProtectionDomain.java:87)
        at java.base/java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(ProtectionDomain.java:97)
        at java.desktop/java.awt.EventQueue$5.run(EventQueue.java:745)
        at java.desktop/java.awt.EventQueue$5.run(EventQueue.java:743)
        at java.base/java.security.AccessController.doPrivileged(Native Method)
        at java.base/java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(ProtectionDomain.java:87)
        at java.desktop/java.awt.EventQueue.dispatchEvent(EventQueue.java:742)
        at org.gvsig.andami.ui.AndamiEventQueue.dispatchEvent(AndamiEventQueue.java:50)
        at java.desktop/java.awt.EventDispatchThread.pumpOneEventForFilters(EventDispatchThread.java:203)
        at java.desktop/java.awt.EventDispatchThread.pumpEventsForFilter(EventDispatchThread.java:124)
        at java.desktop/java.awt.EventDispatchThread.pumpEventsForHierarchy(EventDispatchThread.java:113)
        at java.desktop/java.awt.EventDispatchThread.pumpEvents(EventDispatchThread.java:109)
        at java.desktop/java.awt.EventDispatchThread.pumpEvents(EventDispatchThread.java:101)
        at java.desktop/java.awt.EventDispatchThread.run(EventDispatchThread.java:90)
Caused by: org.gvsig.fmap.dal.feature.exception.FinishEditingException: Can't finish edition.
        at org.gvsig.fmap.dal.feature.impl.DefaultFeatureStore.finishEditing(DefaultFeatureStore.java:1555)
        at org.gvsig.vectorediting.swing.impl.DefaultEditingContext.saveChanges(DefaultEditingContext.java:994)
        ... 45 more
Caused by: java.lang.RuntimeException: Can't perform operation 'PerformChangesOperation'.
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform_operation(AbstractConnectionOperation.java:108)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform(AbstractConnectionOperation.java:43)
        at org.gvsig.fmap.dal.store.jdbc2.spi.JDBCStoreProviderBase.performChanges(JDBCStoreProviderBase.java:521)
        at org.gvsig.fmap.dal.feature.impl.DefaultFeatureStore.finishEditing(DefaultFeatureStore.java:1539)
        ... 46 more
Caused by: org.gvsig.fmap.dal.store.jdbc.exception.JDBCUpdateWithoutChangesException: An update SQL statement has no efect: SQL="{sql}" Values='{sqlValues}'
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.PerformChangesOperation.performUpdates(PerformChangesOperation.java:288)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.PerformChangesOperation.perform(PerformChangesOperation.java:82)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform_operation(AbstractConnectionOperation.java:101)
        ... 49 more

va:108)
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform(AbstractConnectionOperation.java:43)
        at org.gvsig.fmap.dal.store.jdbc2.spi.JDBCStoreProviderBase.performChanges(JDBCStoreProviderBase.java:521)
        at org.gvsig.fmap.dal.feature.impl.DefaultFeatureStore.finishEditing(DefaultFeatureStore.java:1539)
        ... 46 more
Caused by: org.gvsig.fmap.dal.store.jdbc.exception.JDBCUpdateWithoutChangesException: An update SQL statement has no
efect: SQL="{sql}" Values='{sqlValues}'
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.PerformChangesOperation.performUpdates(PerformChangesOperation.java:288)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.PerformChangesOperation.perform(PerformChangesOperation.java:82)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform_operation(AbstractConnectionOperation.java:101)
        ... 49 more

)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.PerformChangesOperation.perform(PerformChangesOperation.java:82)
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform_operation(AbstractConnectionOperation.java:101)
        ... 49 more

va:101)
        ... 49 more

Al parecer, el campo "pk" de la feature, cuando llega el momento de componer la SQL vale NULL.

Si solo muevo un vertice, si que funciona ¿?

EBUG 351345 AWT-EventQueue-0 org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation - Excuting
operation PerformChangesOperation.
DEBUG 351346 AWT-EventQueue-0 org.gvsig.fmap.dal.store.jdbc2.JDBCUtils - execute update SQL= UPDATE
"PUBLIC"."capa_lineas" SET "GEOMETRY" = ST_GeomFromWKB((?), (?)), "Campo1" = ? WHERE ( ("pk") = (?) ) [[ prep325:
UPDATE "PUBLIC"."capa_lineas" SET "GEOMETRY" = ST_GeomFromWKB((?), (?)), "Campo1" = ? WHERE ( ("pk") = (?) )
{1:
X'00000000020000000b4095de928eea490c4099d4bd00bad1d24095dff50e9d61a74099d2312eb3940f4095aaa33050697f4099b6066b1574cc40952f350503a059409986b2adca5cb640949f0f5b938851409946bd18036ede409458da9f335a5a40992a099257621b40940097f7c53b0a409908b045c088214093aec773b0ec3a4098e2b2b610f8d040937dcfa6f154b54098d1521fcbba3c409306323acc4bdd4098910af33019c34092db55da039afb40983b43645bff5e', 2: 25830, 3: '', 4: 11} ]]

9b6066b1574cc40952f350503a059409986b2adca5cb640949f0f5b938851409946bd18036ede409458da9f335a5a40992a099257621b40940097f7c53b0a409908b045c088214093aec773b0ec3a4098e2b2b610f8d040937dcfa6f154b54098d1521fcbba3c409306323acc4bdd4098910af33019c34092db55da039afb40983b43645bff5e', 2: 25830, 3: '', 4: 11} ]]

57621b40940097f7c53b0a409908b045c088214093aec773b0ec3a4098e2b2b610f8d040937dcfa6f154b54098d1521fcbba3c409306323acc4bdd4098910af33019c34092db55da039afb40983b43645bff5e', 2: 25830, 3: '', 4: 11} ]]

9306323acc4bdd4098910af33019c34092db55da039afb40983b43645bff5e', 2: 25830, 3: '', 4: 11} ]]

En general, si muevo mas de un vertice falla.

Adjunto zip con los datos.

Related issues:
Blocks Application: gvSIG desktop - gvSIG bugs # 5171: error al editar base P... Closed 11/27/2019

Associated revisions
Revision 44641 - 12/12/2019 05:13 PM - Joaquín  del Cerro Murciano

refs #5182,corregido para que cuando crea una feature a parir de otra, copia todos los atributos que no sean calculados, aunque sean de solo lectura
o automaticos.

History
#1 - 12/12/2019 11:13 AM - Joaquín  del Cerro Murciano
- Blocks gvSIG bugs #5171: error al editar base PostGIS en gvSIG 2.4 portable added

#2 - 12/12/2019 12:01 PM - Joaquín  del Cerro Murciano
- File #5171 error al editar base PostGIS en gvSIG 2.4 portable.zip added

#3 - 12/12/2019 12:03 PM - Joaquín  del Cerro Murciano

La edicion desde la tabla hace algo raro, pero no falla, modifique uno o mas de un registro.

Lo raro que hace es que desde el momento que modifica un registro muestra la "pk" de ese registro vacia, y no reaparece hasta que no cerramos
edicion.

#4 - 12/12/2019 05:13 PM - Joaquín  del Cerro Murciano
- Status changed from New to Fixed

#5 - 01/21/2020 07:42 PM - Álvaro Anguix
- Status changed from Fixed to Closed
Files
#5171 error al editar base PostGIS en gvSIG 2.4 portable.zip 2.83 MB 12/12/2019 Joaquín  del Cerro Murciano
